//### This file created by BYACC 1.8(/Java extension  1.13)
//### Java capabilities added 7 Jan 97, Bob Jamison
//### Updated : 27 Nov 97  -- Bob Jamison, Joe Nieten
//###           01 Jan 98  -- Bob Jamison -- fixed generic semantic constructor
//###           01 Jun 99  -- Bob Jamison -- added Runnable support
//###           06 Aug 00  -- Bob Jamison -- made state variables class-global
//###           03 Jan 01  -- Bob Jamison -- improved flags, tracing
//###           16 May 01  -- Bob Jamison -- added custom stack sizing
//###           04 Mar 02  -- Yuval Oren  -- improved java performance, added options
//###           14 Mar 02  -- Tomas Hurka -- -d support, static initializer workaround
//### Please send bug reports to tom@hukatronic.cz
//### static char yysccsid[] = "@(#)yaccpar	1.8 (Berkeley) 01/20/90";



package com.thoughtworks.qdox.parser.impl;



//#line 2 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
import com.thoughtworks.qdox.parser.*;
import com.thoughtworks.qdox.parser.structs.*;
import com.thoughtworks.qdox.model.*;
import com.thoughtworks.qdox.model.annotation.*;
import java.io.IOException;
import java.util.LinkedList;
import java.util.ArrayList;
import java.util.List;
import java.util.Stack;
//#line 27 "Parser.java"




public class Parser
{

boolean yydebug;        //do I want debug output?
int yynerrs;            //number of errors so far
int yyerrflag;          //was there an error?
int yychar;             //the current working character

//########## MESSAGES ##########
//###############################################################
// method: debug
//###############################################################
void debug(String msg)
{
  if (yydebug)
    System.out.println(msg);
}

//########## STATE STACK ##########
final static int YYSTACKSIZE = 500;  //maximum stack size
int statestk[] = new int[YYSTACKSIZE]; //state stack
int stateptr;
int stateptrmax;                     //highest index of stackptr
int statemax;                        //state when highest index reached
//###############################################################
// methods: state stack push,pop,drop,peek
//###############################################################
final void state_push(int state)
{
  try {
		stateptr++;
		statestk[stateptr]=state;
	 }
	 catch (ArrayIndexOutOfBoundsException e) {
     int oldsize = statestk.length;
     int newsize = oldsize * 2;
     int[] newstack = new int[newsize];
     System.arraycopy(statestk,0,newstack,0,oldsize);
     statestk = newstack;
     statestk[stateptr]=state;
  }
}
final int state_pop()
{
  return statestk[stateptr--];
}
final void state_drop(int cnt)
{
  stateptr -= cnt; 
}
final int state_peek(int relative)
{
  return statestk[stateptr-relative];
}
//###############################################################
// method: init_stacks : allocate and prepare stacks
//###############################################################
final boolean init_stacks()
{
  stateptr = -1;
  val_init();
  return true;
}
//###############################################################
// method: dump_stacks : show n levels of the stacks
//###############################################################
void dump_stacks(int count)
{
int i;
  System.out.println("=index==state====value=     s:"+stateptr+"  v:"+valptr);
  for (i=0;i<count;i++)
    System.out.println(" "+i+"    "+statestk[i]+"      "+valstk[i]);
  System.out.println("======================");
}


//########## SEMANTIC VALUES ##########
//## **user defined:Value
String   yytext;//user variable to return contextual strings
Value yyval; //used to return semantic vals from action routines
Value yylval;//the 'lval' (result) I got from yylex()
Value valstk[] = new Value[YYSTACKSIZE];
int valptr;
//###############################################################
// methods: value stack push,pop,drop,peek.
//###############################################################
final void val_init()
{
  yyval=new Value();
  yylval=new Value();
  valptr=-1;
}
final void val_push(Value val)
{
  try {
    valptr++;
    valstk[valptr]=val;
  }
  catch (ArrayIndexOutOfBoundsException e) {
    int oldsize = valstk.length;
    int newsize = oldsize*2;
    Value[] newstack = new Value[newsize];
    System.arraycopy(valstk,0,newstack,0,oldsize);
    valstk = newstack;
    valstk[valptr]=val;
  }
}
final Value val_pop()
{
  return valstk[valptr--];
}
final void val_drop(int cnt)
{
  valptr -= cnt;
}
final Value val_peek(int relative)
{
  return valstk[valptr-relative];
}
//#### end semantic value section ####
public final static short SEMI=257;
public final static short DOT=258;
public final static short DOTDOTDOT=259;
public final static short COMMA=260;
public final static short STAR=261;
public final static short PERCENT=262;
public final static short EQUALS=263;
public final static short ANNOSTRING=264;
public final static short ANNOCHAR=265;
public final static short SLASH=266;
public final static short PLUS=267;
public final static short MINUS=268;
public final static short PACKAGE=269;
public final static short IMPORT=270;
public final static short PUBLIC=271;
public final static short PROTECTED=272;
public final static short PRIVATE=273;
public final static short STATIC=274;
public final static short FINAL=275;
public final static short ABSTRACT=276;
public final static short NATIVE=277;
public final static short STRICTFP=278;
public final static short SYNCHRONIZED=279;
public final static short TRANSIENT=280;
public final static short VOLATILE=281;
public final static short CLASS=282;
public final static short INTERFACE=283;
public final static short ENUM=284;
public final static short ANNOINTERFACE=285;
public final static short THROWS=286;
public final static short EXTENDS=287;
public final static short IMPLEMENTS=288;
public final static short SUPER=289;
public final static short DEFAULT=290;
public final static short BRACEOPEN=291;
public final static short BRACECLOSE=292;
public final static short SQUAREOPEN=293;
public final static short SQUARECLOSE=294;
public final static short PARENOPEN=295;
public final static short PARENCLOSE=296;
public final static short LESSTHAN=297;
public final static short GREATERTHAN=298;
public final static short LESSEQUALS=299;
public final static short GREATEREQUALS=300;
public final static short LESSTHAN2=301;
public final static short GREATERTHAN2=302;
public final static short GREATERTHAN3=303;
public final static short EXCLAMATION=304;
public final static short AMPERSAND2=305;
public final static short VERTLINE2=306;
public final static short EQUALS2=307;
public final static short NOTEQUALS=308;
public final static short TILDE=309;
public final static short AMPERSAND=310;
public final static short VERTLINE=311;
public final static short CIRCUMFLEX=312;
public final static short VOID=313;
public final static short QUERY=314;
public final static short COLON=315;
public final static short AT=316;
public final static short JAVADOCSTART=317;
public final static short JAVADOCEND=318;
public final static short JAVADOCEOL=319;
public final static short CODEBLOCK=320;
public final static short PARENBLOCK=321;
public final static short BYTE=322;
public final static short SHORT=323;
public final static short INT=324;
public final static short LONG=325;
public final static short CHAR=326;
public final static short FLOAT=327;
public final static short DOUBLE=328;
public final static short BOOLEAN=329;
public final static short IDENTIFIER=330;
public final static short JAVADOCTAG=331;
public final static short JAVADOCTOKEN=332;
public final static short BOOLEAN_LITERAL=333;
public final static short INTEGER_LITERAL=334;
public final static short LONG_LITERAL=335;
public final static short FLOAT_LITERAL=336;
public final static short DOUBLE_LITERAL=337;
public final static short CHAR_LITERAL=338;
public final static short STRING_LITERAL=339;
public final static short YYERRCODE=256;
final static short yylhs[] = {                           -1,
    0,   35,    0,   34,   34,   34,   34,   34,   34,   34,
   36,   37,   37,   38,   41,   43,   43,   44,   44,   42,
   42,   46,   45,   23,   23,   23,   31,   28,   28,   24,
   24,   24,   24,   24,   24,   24,   24,   24,   24,   24,
   47,   47,   47,   49,    6,   48,   48,   48,   48,   50,
   50,   51,   52,    7,   53,   53,   54,   54,    3,    3,
    3,    4,    8,    8,    9,    9,   10,   10,   11,   11,
   12,   12,   13,   13,   14,   14,   14,   15,   15,   15,
   15,   15,   16,   16,   16,   16,   17,   17,   17,   18,
   18,   18,   18,   19,   19,   19,   20,   20,   20,   21,
   21,   21,   21,   21,   21,   21,   21,   21,   21,   21,
   22,   22,    1,    1,    5,    5,    5,    5,    5,    5,
    5,    2,    2,    2,    2,    2,    2,    2,    2,   30,
   56,   57,   32,   32,   25,   25,   26,   26,   55,   55,
   33,   33,   33,   33,   58,   58,   59,   60,   60,   61,
   61,   62,   62,   40,   63,   64,   64,   66,   66,   66,
   68,   68,   69,   69,   69,   69,   39,   71,   72,   72,
   72,   73,   73,   74,   74,   65,   65,   75,   75,   67,
   77,   67,   76,   76,   76,   76,   76,   76,   76,   76,
   27,   27,   81,   83,   78,   82,   84,   82,   79,   79,
   80,   85,   86,   86,   88,   88,   87,   87,   89,   89,
   90,   29,   29,   70,   70,   91,   91,
};
final static short yylen[] = {                            2,
    0,    0,    3,    1,    1,    1,    1,    1,    1,    1,
    3,    3,    4,    4,    1,    0,    2,    1,    1,    0,
    2,    0,    3,    1,    3,    3,    2,    0,    3,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    2,    2,    0,    0,    4,    0,    3,    3,    2,    1,
    3,    3,    0,    4,    0,    1,    1,    3,    1,    1,
    1,    1,    1,    5,    1,    3,    1,    3,    1,    3,
    1,    3,    1,    3,    1,    3,    3,    1,    3,    3,
    3,    3,    1,    3,    3,    3,    1,    3,    3,    1,
    3,    3,    3,    2,    2,    1,    2,    2,    1,    4,
    5,    5,    4,    3,    1,    4,    3,    3,    4,    1,
    2,    3,    1,    3,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    2,
    0,    0,    6,    1,    1,    3,    1,    3,    1,    3,
    1,    1,    3,    3,    0,    1,    3,    1,    3,    1,
    3,    1,    3,    4,    4,    1,    3,    0,    1,    3,
    2,    2,    1,    2,    2,    3,    4,    6,    1,    1,
    1,    0,    2,    1,    3,    0,    2,    1,    3,    0,
    0,    3,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    2,    0,    6,    0,    0,    4,    8,    7,
    5,    3,    0,    2,    1,    3,    0,    1,    1,    3,
    5,    0,    1,    0,    2,    0,    2,
};
final static short yydefred[] = {                         1,
    2,    0,   10,    0,    0,    0,   16,    4,    3,    5,
    6,    7,    8,    9,    0,    0,    0,   24,    0,    0,
    0,  113,    0,   20,    0,   30,   31,   32,   33,   34,
   35,   36,   40,   37,   39,   38,  169,  170,    0,  171,
   42,   41,    0,    0,  180,   11,    0,    0,   12,    0,
    0,    0,   19,   18,   17,    0,    0,    0,    0,    0,
    0,    0,    0,   26,   25,   13,  114,    0,   45,   14,
   22,   21,    0,  155,    0,    0,  146,    0,  161,  154,
  180,    0,  215,  162,  167,    0,    0,    0,    0,   49,
    0,    0,  123,  124,  125,  126,  127,  128,  129,  122,
    0,  119,  118,  117,  116,  115,  120,  121,    0,    0,
    0,   59,  105,   60,   61,   62,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,   90,   96,   99,    0,
   50,    0,   16,  137,    0,    0,    0,    0,    0,    0,
  148,    0,    0,  164,    0,    0,  160,  190,  183,  188,
  189,    0,  182,  184,  185,  186,  187,   94,   95,    0,
    0,    0,   98,   97,    0,    0,    0,    0,    0,    0,
   47,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,   48,    0,    0,  131,    0,    0,    0,    0,
    0,  147,    0,    0,  168,  166,  193,    0,    0,    0,
    0,    0,    0,    0,    0,  104,   52,  108,  111,    0,
    0,  107,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
   91,   93,   92,    0,   51,   57,    0,    0,    0,  138,
  136,    0,  152,    0,  149,    0,    0,    0,    0,  194,
    0,    0,  103,    0,  100,    0,  109,  112,  106,    0,
   54,    0,    0,  141,  139,    0,    0,    0,    0,    0,
    0,  209,    0,    0,    0,   28,  196,    0,    0,  102,
  101,   64,   58,    0,    0,    0,    0,  153,    0,  202,
  214,    0,    0,  191,  192,  201,    0,    0,   29,   28,
  143,  144,  140,  133,  217,    0,  210,    0,    0,  197,
  195,    0,  213,    0,    0,  200,    0,    0,   28,  211,
  198,  199,
};
final static short yydgoto[] = {                          1,
  109,  110,  111,  112,  113,  114,  115,  116,  117,  118,
  119,  120,  121,  122,  123,  124,  125,  126,  127,  128,
  129,  168,   19,   42,  135,  136,  306,  285,  324,  274,
  260,  210,  275,    9,    2,   10,   11,   58,   13,   14,
   24,   52,   25,   55,   72,  133,   15,   69,   51,  130,
  131,  132,  247,  248,  276,  249,  297,   76,   77,  140,
  141,  254,   16,   59,   74,   60,   63,   61,   79,   62,
   17,   43,  143,  204,  138,  153,   86,  154,  155,  156,
  157,  308,  287,  327,  258,  284,  280,  303,  281,  282,
  299,
};
final static short yysindex[] = {                         0,
    0, -194,    0, -266, -253, -188,    0,    0,    0,    0,
    0,    0,    0,    0,  789, -177, -145,    0,  -19, -266,
  131,    0,  -97,    0,  -84,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0, -140,    0,
    0,    0,  -77, -123,    0,    0, -246,  159,    0,  -68,
   -3,   14,    0,    0,    0,   31,   42,   27,   41,  115,
  104, -277,   86,    0,    0,    0,    0,   57,    0,    0,
    0,    0,   70,    0,   72,  111,    0,   99,    0,    0,
    0, -123,    0,    0,    0, -216,  147,  147,  147,    0,
  147,  147,    0,    0,    0,    0,    0,    0,    0,    0,
  142,    0,    0,    0,    0,    0,    0,    0, -128,  -69,
  114,    0,    0,    0,    0,    0, -121,  118,  132,  149,
  155,  126, -180,  106,  182,   76,    0,    0,    0, -165,
    0,  177,    0,    0,  232,  272,  273,  274,  246, -144,
    0,   70,   31,    0,  215,    0,    0,    0,    0,    0,
    0,  216,    0,    0,    0,    0,    0,    0,    0, -164,
  -70,  241,    0,    0,  102, -209,  244,   36,  257,   37,
    0,  147,  147,  147,  147,  147,  147,  147,  147,  147,
  147,  147,  147,  147,  147,  147,  147,  147,  147,  147,
  147,  211,    0,  102,  -84,    0,  212,  213,   70,   70,
   72,    0,  273,  284,    0,    0,    0,  250,  228,  273,
   70,  794,  -36,  147,  -27,    0,    0,    0,    0,  278,
  268,    0,  282,  118,  251,  132,  149,  155,  126, -180,
 -180,  106,  106,  106,  106,  182,  182,  182,   76,   76,
    0,    0,    0,  142,    0,    0,  275,  305,  -67,    0,
    0,  273,    0,  258,    0,   70,    0,  285,  250,    0,
  277,  255,    0,  794,    0,  147,    0,    0,    0,  147,
    0,  102, -149,    0,    0,  326,   70,  273,  283,  292,
  333,    0, -266, -235,  277,    0,    0,  295,  250,    0,
    0,    0,    0,   70,   70,  -67,  296,    0,  231,    0,
    0,  340,  342,    0,    0,    0,  -43, -224,    0,    0,
    0,    0,    0,    0,    0,  341,    0, -266, -235,    0,
    0,  -43,    0,  279,  340,    0,  279, -235,    0,    0,
    0,    0,
};
final static short yyrindex[] = {                         0,
    0,  863,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    1,    0,   17,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0, -244,    0,    0,    0,    0,    0,    0,
   30,    0,    0,    0,    0,  312,   53,    0,    0,  315,
   59,    0,  -76,    0,    0,    0,    0,  313,    0,    0,
    0,    0,    0,    0,    0,   67,    0,  -41,    0,    0,
    0, -244,    0,    0,    0,  243,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  329,    0,    0,    0,    0,    0,    0,    0,  350,    0,
    0,    0,    0,    0,    0,    0, -157,  -47,  -50,  717,
  378, -155,  -78,  567,  448,  399,    0,    0,    0,    0,
    0,    0,    0,    0, -242, -231, -236,  317, -136,    0,
    0,    0,  312,    0,  -40, -105,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  785,
    0,    0,    0,    0,  313,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  161,   18,    0,    0,    0,    0,    0,
    0,    0,   68,   80,    0,    0,    0, -239,    0, -228,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  107,    0,  744,  728,  700,  309,  152,
  679,  595,  616,  637,  658,  497,  518,  546,  420,  469,
    0,    0,    0,    0,    0,    0,    0,  321,    0,    0,
    0,   29,    0, -135,    0,    0,  276, -212, -222,    0,
 -217,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  313, -107,    0,    0,  346,    0,   74,  303,    0,
  349,    0,    0,    0, -237,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0, -220, -205,    0,    0,    0, -212,    0,    0,    0,
    0,    0,    0,    0,    0,  324,    0,    0,    0,    0,
    0, -212,    0,    0, -213,    0,    0,    0,    0,    0,
    0,    0,
};
final static short yygindex[] = {                         0,
    3,  574, -160,  -86,    0,   12,    0,    0,    0,  496,
  495,  498,  499,  494,  300,  194,  261,  267,  -80, -186,
    0,  -13,    5,  373,    0,    0,   35, -206,    0, -150,
   77,  -73,  380,    0,    0,    0,    0,    4,  591,  592,
    0,    0,  548,    0,    0,    0,  593,    0,    0,    0,
  490,    0,    0,    0,    0,    0,    0,    0,  533,    0,
  485,    0,    0,    0,  551,  621,  634,    0,  662, -168,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0, -153, -179,    0,    0,    0,  432,
    0,
};
final static int YYTABLESIZE=1148;
static short yytable[];
static { yytable();}
static void yytable(){
yytable = new short[]{                        137,
   44,  209,  162,  261,  217,   12,  158,  159,   23,   21,
  163,  164,  158,    8,   64,  134,  134,  134,  137,   27,
   20,  304,   27,  178,   48,  263,   41,  135,  135,   46,
   28,   28,  304,  246,   28,  320,  205,   28,    6,  205,
  148,  130,  130,  206,  203,  134,  206,  158,  134,  253,
  134,  204,   78,  137,  178,  134,  135,  137,   27,  135,
  262,  135,    3,   18,   28,  135,  135,  134,  203,   28,
   28,  214,  218,   83,    4,    5,   18,  290,  135,  307,
  130,   28,   27,   65,  305,  214,  225,  134,  279,  149,
  137,  160,  130,  166,  192,  305,  170,   28,  135,  205,
    7,   28,   63,  322,   73,  286,  206,  203,  241,  242,
  243,  293,  130,   44,  204,  201,  180,  181,  182,  183,
   67,    6,    7,  150,  151,  252,  298,  319,  167,  166,
  193,  212,  279,  265,   63,  310,   73,  294,   63,  295,
   73,   22,  328,  311,  312,   45,  213,  215,  316,   73,
   73,  181,  142,  202,   73,   73,   73,   63,   73,   73,
   50,  150,  151,   41,  167,  181,  181,  181,  181,  181,
  181,  181,  181,  181,  181,  181,  181,  181,  181,  181,
  181,   75,  278,  292,  172,  291,  157,  169,  169,   56,
  142,  181,  173,    7,  181,  181,  181,  181,  181,  181,
  181,  181,  181,  181,  181,  181,  181,  181,  181,   67,
  181,  181,   65,   75,  181,  163,  165,   75,  163,  165,
  181,  220,  167,  167,  181,  214,   75,   75,   75,   75,
  223,   75,   75,   75,   53,   75,   75,   46,   47,  181,
  181,   67,  283,  181,   65,   67,  273,   54,   65,  288,
  163,  165,   57,  181,   67,   67,  221,   44,   65,  264,
   44,   67,  134,   67,   67,  221,   65,   65,  266,   44,
   44,   44,   44,   44,   44,   44,   44,   44,   44,   44,
   44,   44,   44,   44,   44,   44,   46,  302,  179,   46,
   83,   68,   44,  220,  223,   44,   44,   44,   46,   46,
   46,   46,   46,   46,   46,   46,   46,   46,   46,   46,
   46,   46,   46,   46,   46,  159,   44,   44,   73,  179,
   44,   46,  325,   87,   88,   46,   46,  174,  221,  221,
   44,   70,   80,  175,   15,   23,  189,  190,   75,  145,
  145,  191,  321,  145,   71,   46,   46,   15,   23,   46,
  159,   89,   90,  326,  172,  174,   78,  172,  174,   46,
   91,  175,  332,   82,  175,   92,   66,  173,   87,   88,
  173,   81,    6,  232,  233,  234,  235,   85,   93,   94,
   95,   96,   97,   98,   99,  100,  101,   49,   47,  102,
  103,  104,  105,  106,  107,  108,   89,  142,   66,  134,
  330,  139,   66,  331,  165,   91,  184,  185,  186,  171,
   92,   76,   66,   87,   88,   66,   47,    6,  144,  145,
   66,   66,  174,   93,   94,   95,   96,   97,   98,   99,
  100,   22,  178,  179,  102,  103,  104,  105,  106,  107,
  108,   89,  175,   76,  236,  237,  238,   76,  187,  188,
   91,   53,   55,  239,  240,   92,   76,   76,   76,   76,
  176,   76,   76,   76,  177,   76,   76,  194,   93,   94,
   95,   96,   97,   98,   99,  100,   22,  230,  231,  102,
  103,  104,  105,  106,  107,  108,   26,   27,   28,   29,
   30,   31,   32,   33,   34,   35,   36,   37,   38,   39,
   40,   26,   27,   28,   29,   30,   31,   32,   33,   34,
   35,   36,   75,   43,   43,   43,   43,   43,   43,   43,
   43,   43,   43,   43,   43,   43,   43,   43,  196,  197,
  198,    6,  200,  199,  206,  207,  216,  219,  222,   43,
  244,  250,  251,  256,  257,  208,  214,  214,  214,  214,
  214,  214,  214,  214,  214,  214,  214,  259,   43,  267,
  134,  268,   43,  269,  272,  270,  271,  277,   74,  288,
  283,  207,   43,  216,  216,  216,  216,  216,  216,  216,
  216,  216,  216,  216,  289,  296,  113,  300,  309,  113,
  113,  214,  301,  314,  113,  113,  113,   47,    6,  323,
   74,  318,  176,   53,   74,  214,  156,  177,  329,  110,
  110,  110,   56,   74,   74,  110,  110,  110,   74,   74,
   74,  113,   74,   74,  113,  113,  113,  113,  113,  113,
  113,  113,  216,  113,  113,  113,  113,   71,  113,  113,
  113,  110,  113,  132,  208,  110,  110,  110,  110,  110,
  110,  110,  110,  212,  110,  110,  110,  110,   87,  110,
  110,  110,  161,  110,  110,   87,   87,  224,  226,   71,
  229,  315,  227,   71,  228,  313,  150,  151,  152,   88,
  195,  245,   71,   71,  211,  255,   88,   88,   71,   71,
   87,   71,   71,  205,   87,   87,   87,   87,   87,   87,
   87,   87,  147,   87,   87,   87,   87,   83,   87,   87,
   87,   88,   87,   87,  146,   88,   88,   88,   88,   88,
   88,   88,   88,   84,   88,   88,   88,   88,   89,   88,
   88,   88,  317,   88,   88,   89,   89,    0,    0,   83,
    0,    0,    0,   83,   83,   83,   83,   83,   83,   83,
   83,    0,   83,   83,   83,   83,   84,   83,   83,   83,
   89,   83,   83,    0,   89,   89,   89,   89,   89,   89,
   89,   89,    0,   89,   89,   89,   89,   86,   89,   89,
   89,    0,   89,   89,    0,    0,    0,    0,   84,    0,
    0,    0,   84,   84,   84,   84,   84,   84,   84,   84,
    0,   84,   84,   84,   84,   85,   84,   84,   84,   86,
   84,   84,    0,   86,   86,   86,   86,   86,   86,   86,
   86,    0,   86,   86,   86,   86,   78,   86,   86,   86,
    0,   86,   86,    0,    0,    0,    0,   85,    0,    0,
    0,   85,   85,   85,   85,   85,   85,   85,   85,    0,
   85,   85,   85,   85,   81,   85,   85,   85,   78,   85,
   85,    0,   78,   78,   78,   78,   78,    0,    0,    0,
    0,   78,   78,   78,   78,   82,   78,   78,   78,    0,
   78,   78,    0,    0,    0,    0,   81,    0,    0,    0,
   81,   81,   81,   81,   81,    0,   79,    0,    0,   81,
   81,   81,   81,    0,   81,   81,   81,   82,   81,   81,
    0,   82,   82,   82,   82,   82,    0,   80,    0,    0,
   82,   82,   82,   82,    0,   82,   82,   82,   79,   82,
   82,    0,   79,   79,   79,   79,   79,    0,   77,    0,
    0,   79,   79,   79,   79,    0,   79,   79,   79,   80,
   79,   79,    0,   80,   80,   80,   80,   80,    0,   72,
    0,    0,   80,   80,   80,   80,    0,   80,   80,   80,
   77,   80,   80,    0,   77,    0,   69,    0,    0,    0,
    0,    0,    0,   77,   77,   77,   77,   70,   77,   77,
   77,   72,   77,   77,    0,   72,    0,    0,    0,    0,
    0,    0,    0,   68,   72,   72,    0,    0,   69,    0,
   72,   72,   69,   72,   72,    0,    0,    0,    0,   70,
    0,   69,   69,   70,    0,    0,    0,   69,    0,    0,
   69,   69,   70,   70,    0,   68,    0,    0,   70,   68,
    0,   70,   70,    0,    0,  110,  110,    0,   68,   68,
  110,  110,  110,    0,    0,    0,    0,   68,   68,   26,
   27,   28,   29,   30,   31,   32,   33,   34,   35,   36,
   37,   38,   39,   40,    0,    0,    0,    0,    0,    0,
    0,  110,  110,  110,  110,  110,  110,  110,   89,  110,
  110,  110,  110,    0,  110,  110,  110,   91,  110,    0,
    0,    0,   92,    0,    6,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,   93,   94,   95,   96,   97,
   98,   99,  100,   22,    0,    0,  102,  103,  104,  105,
  106,  107,  108,   43,   43,   43,   43,   43,   43,   43,
   43,   43,   43,   43,   43,   43,   43,   43,
};
}
static short yycheck[];
static { yycheck(); }
static void yycheck() {
yycheck = new short[] {                         73,
    0,  152,   89,  210,  165,    2,   87,   88,    6,    5,
   91,   92,  257,    2,  261,  258,  259,  260,  258,  257,
  274,  257,  260,  260,   20,  212,   15,  259,  260,    0,
  259,  260,  257,  194,  257,  260,  257,  260,  316,  260,
  257,  259,  260,  257,  257,  288,  260,  292,  291,  200,
  293,  257,  330,  293,  291,  298,  288,  297,  296,  291,
  211,  293,  257,  330,  293,  297,  298,  310,  142,  298,
  293,  316,  282,   62,  269,  270,  330,  264,  310,  286,
  298,  310,  320,  330,  320,  330,  173,  330,  257,   86,
  330,   89,  310,  258,  260,  320,  110,  320,  330,  320,
  317,  330,  260,  310,  260,  259,  320,  320,  189,  190,
  191,  272,  330,  291,  320,  260,  297,  298,  299,  300,
  330,  316,  317,  260,  260,  199,  277,  307,  293,  258,
  296,  296,  301,  214,  292,  289,  292,  287,  296,  289,
  296,  330,  322,  294,  295,  291,  160,  161,  299,  305,
  306,  257,  260,  298,  310,  311,  312,  315,  314,  315,
  258,  298,  298,  152,  293,  271,  272,  273,  274,  275,
  276,  277,  278,  279,  280,  281,  282,  283,  284,  285,
  257,  260,  256,  270,  306,  266,  292,  258,  258,  330,
  298,  297,  314,  317,  271,  272,  273,  274,  275,  276,
  277,  278,  279,  280,  281,  282,  283,  284,  285,  260,
  316,  317,  260,  292,  320,  257,  257,  296,  260,  260,
  297,  258,  293,  293,  330,  296,  305,  306,  307,  308,
  258,  310,  311,  312,  319,  314,  315,  257,  258,  316,
  317,  292,  286,  320,  292,  296,  314,  332,  296,  293,
  292,  292,  330,  330,  305,  306,  293,  257,  306,  296,
  260,  330,  330,  314,  315,  293,  314,  315,  296,  269,
  270,  271,  272,  273,  274,  275,  276,  277,  278,  279,
  280,  281,  282,  283,  284,  285,  257,  283,  260,  260,
  279,  295,  292,  258,  258,  295,  296,  297,  269,  270,
  271,  272,  273,  274,  275,  276,  277,  278,  279,  280,
  281,  282,  283,  284,  285,  257,  316,  317,  288,  291,
  320,  292,  318,  267,  268,  296,  297,  260,  293,  293,
  330,  318,  292,  260,  318,  318,  261,  262,  297,  287,
  288,  266,  308,  291,  331,  316,  317,  331,  331,  320,
  292,  295,  296,  319,  288,  288,  330,  291,  291,  330,
  304,  288,  328,  260,  291,  309,  260,  288,  267,  268,
  291,  257,  316,  180,  181,  182,  183,  292,  322,  323,
  324,  325,  326,  327,  328,  329,  330,  257,  258,  333,
  334,  335,  336,  337,  338,  339,  295,  287,  292,  330,
  324,  330,  296,  327,  263,  304,  301,  302,  303,  296,
  309,  260,  306,  267,  268,  257,  258,  316,  320,  321,
  314,  315,  305,  322,  323,  324,  325,  326,  327,  328,
  329,  330,  307,  308,  333,  334,  335,  336,  337,  338,
  339,  295,  311,  292,  184,  185,  186,  296,  267,  268,
  304,  291,  292,  187,  188,  309,  305,  306,  307,  308,
  312,  310,  311,  312,  310,  314,  315,  291,  322,  323,
  324,  325,  326,  327,  328,  329,  330,  178,  179,  333,
  334,  335,  336,  337,  338,  339,  271,  272,  273,  274,
  275,  276,  277,  278,  279,  280,  281,  282,  283,  284,
  285,  271,  272,  273,  274,  275,  276,  277,  278,  279,
  280,  281,  297,  271,  272,  273,  274,  275,  276,  277,
  278,  279,  280,  281,  282,  283,  284,  285,  297,  258,
  258,  316,  287,  260,  320,  320,  296,  294,  282,  297,
  330,  330,  330,  260,  295,  330,  271,  272,  273,  274,
  275,  276,  277,  278,  279,  280,  281,  330,  316,  282,
  330,  294,  320,  282,  260,  315,  292,  310,  260,  293,
  286,  296,  330,  271,  272,  273,  274,  275,  276,  277,
  278,  279,  280,  281,  330,  260,  258,  296,  294,  261,
  262,  316,  260,  298,  266,  267,  268,  258,  316,  259,
  292,  260,  291,  291,  296,  330,  292,  291,  330,  260,
  261,  262,  292,  305,  306,  266,  267,  268,  310,  311,
  312,  293,  314,  315,  296,  297,  298,  299,  300,  301,
  302,  303,  330,  305,  306,  307,  308,  260,  310,  311,
  312,  292,  314,  298,  296,  296,  297,  298,  299,  300,
  301,  302,  303,  330,  305,  306,  307,  308,  260,  310,
  311,  312,   89,  314,  315,  267,  268,  172,  174,  292,
  177,  299,  175,  296,  176,  296,   86,   86,   86,  260,
  133,  192,  305,  306,  152,  201,  267,  268,  311,  312,
  292,  314,  315,  143,  296,  297,  298,  299,  300,  301,
  302,  303,   82,  305,  306,  307,  308,  260,  310,  311,
  312,  292,  314,  315,   81,  296,  297,  298,  299,  300,
  301,  302,  303,   62,  305,  306,  307,  308,  260,  310,
  311,  312,  301,  314,  315,  267,  268,   -1,   -1,  292,
   -1,   -1,   -1,  296,  297,  298,  299,  300,  301,  302,
  303,   -1,  305,  306,  307,  308,  260,  310,  311,  312,
  292,  314,  315,   -1,  296,  297,  298,  299,  300,  301,
  302,  303,   -1,  305,  306,  307,  308,  260,  310,  311,
  312,   -1,  314,  315,   -1,   -1,   -1,   -1,  292,   -1,
   -1,   -1,  296,  297,  298,  299,  300,  301,  302,  303,
   -1,  305,  306,  307,  308,  260,  310,  311,  312,  292,
  314,  315,   -1,  296,  297,  298,  299,  300,  301,  302,
  303,   -1,  305,  306,  307,  308,  260,  310,  311,  312,
   -1,  314,  315,   -1,   -1,   -1,   -1,  292,   -1,   -1,
   -1,  296,  297,  298,  299,  300,  301,  302,  303,   -1,
  305,  306,  307,  308,  260,  310,  311,  312,  292,  314,
  315,   -1,  296,  297,  298,  299,  300,   -1,   -1,   -1,
   -1,  305,  306,  307,  308,  260,  310,  311,  312,   -1,
  314,  315,   -1,   -1,   -1,   -1,  292,   -1,   -1,   -1,
  296,  297,  298,  299,  300,   -1,  260,   -1,   -1,  305,
  306,  307,  308,   -1,  310,  311,  312,  292,  314,  315,
   -1,  296,  297,  298,  299,  300,   -1,  260,   -1,   -1,
  305,  306,  307,  308,   -1,  310,  311,  312,  292,  314,
  315,   -1,  296,  297,  298,  299,  300,   -1,  260,   -1,
   -1,  305,  306,  307,  308,   -1,  310,  311,  312,  292,
  314,  315,   -1,  296,  297,  298,  299,  300,   -1,  260,
   -1,   -1,  305,  306,  307,  308,   -1,  310,  311,  312,
  292,  314,  315,   -1,  296,   -1,  260,   -1,   -1,   -1,
   -1,   -1,   -1,  305,  306,  307,  308,  260,  310,  311,
  312,  292,  314,  315,   -1,  296,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  260,  305,  306,   -1,   -1,  292,   -1,
  311,  312,  296,  314,  315,   -1,   -1,   -1,   -1,  292,
   -1,  305,  306,  296,   -1,   -1,   -1,  311,   -1,   -1,
  314,  315,  305,  306,   -1,  292,   -1,   -1,  311,  296,
   -1,  314,  315,   -1,   -1,  261,  262,   -1,  305,  306,
  266,  267,  268,   -1,   -1,   -1,   -1,  314,  315,  271,
  272,  273,  274,  275,  276,  277,  278,  279,  280,  281,
  282,  283,  284,  285,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  297,  298,  299,  300,  301,  302,  303,  295,  305,
  306,  307,  308,   -1,  310,  311,  312,  304,  314,   -1,
   -1,   -1,  309,   -1,  316,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  322,  323,  324,  325,  326,
  327,  328,  329,  330,   -1,   -1,  333,  334,  335,  336,
  337,  338,  339,  271,  272,  273,  274,  275,  276,  277,
  278,  279,  280,  281,  282,  283,  284,  285,
};
}
final static short YYFINAL=1;
final static short YYMAXTOKEN=339;
final static String yyname[] = {
"end-of-file",null,null,null,null,null,null,null,null,null,null,null,null,null,
null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,
null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,
null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,
null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,
null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,
null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,
null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,
null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,
null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,
null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,
null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,
null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,
null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,
null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,
null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,
null,null,null,"SEMI","DOT","DOTDOTDOT","COMMA","STAR","PERCENT","EQUALS",
"ANNOSTRING","ANNOCHAR","SLASH","PLUS","MINUS","PACKAGE","IMPORT","PUBLIC",
"PROTECTED","PRIVATE","STATIC","FINAL","ABSTRACT","NATIVE","STRICTFP",
"SYNCHRONIZED","TRANSIENT","VOLATILE","CLASS","INTERFACE","ENUM",
"ANNOINTERFACE","THROWS","EXTENDS","IMPLEMENTS","SUPER","DEFAULT","BRACEOPEN",
"BRACECLOSE","SQUAREOPEN","SQUARECLOSE","PARENOPEN","PARENCLOSE","LESSTHAN",
"GREATERTHAN","LESSEQUALS","GREATEREQUALS","LESSTHAN2","GREATERTHAN2",
"GREATERTHAN3","EXCLAMATION","AMPERSAND2","VERTLINE2","EQUALS2","NOTEQUALS",
"TILDE","AMPERSAND","VERTLINE","CIRCUMFLEX","VOID","QUERY","COLON","AT",
"JAVADOCSTART","JAVADOCEND","JAVADOCEOL","CODEBLOCK","PARENBLOCK","BYTE",
"SHORT","INT","LONG","CHAR","FLOAT","DOUBLE","BOOLEAN","IDENTIFIER",
"JAVADOCTAG","JAVADOCTOKEN","BOOLEAN_LITERAL","INTEGER_LITERAL","LONG_LITERAL",
"FLOAT_LITERAL","DOUBLE_LITERAL","CHAR_LITERAL","STRING_LITERAL",
};
final static String yyrule[] = {
"$accept : file",
"file :",
"$$1 :",
"file : file $$1 filepart",
"filepart : annotation",
"filepart : package",
"filepart : import",
"filepart : javadoc",
"filepart : class",
"filepart : enum",
"filepart : SEMI",
"package : PACKAGE fullidentifier SEMI",
"import : IMPORT fullidentifier SEMI",
"import : IMPORT STATIC fullidentifier SEMI",
"javadoc : JAVADOCSTART javadocdescription javadoctags JAVADOCEND",
"javadocdescription : javadoctokens",
"javadoctokens :",
"javadoctokens : javadoctokens javadoctoken",
"javadoctoken : JAVADOCTOKEN",
"javadoctoken : JAVADOCEOL",
"javadoctags :",
"javadoctags : javadoctags javadoctag",
"$$2 :",
"javadoctag : JAVADOCTAG $$2 javadoctokens",
"fullidentifier : IDENTIFIER",
"fullidentifier : fullidentifier DOT IDENTIFIER",
"fullidentifier : fullidentifier DOT STAR",
"arrayidentifier : IDENTIFIER dimensions",
"dimensions :",
"dimensions : dimensions SQUAREOPEN SQUARECLOSE",
"modifier : PUBLIC",
"modifier : PROTECTED",
"modifier : PRIVATE",
"modifier : STATIC",
"modifier : FINAL",
"modifier : ABSTRACT",
"modifier : NATIVE",
"modifier : SYNCHRONIZED",
"modifier : VOLATILE",
"modifier : TRANSIENT",
"modifier : STRICTFP",
"modifiers : modifiers modifier",
"modifiers : modifiers annotation",
"modifiers :",
"$$3 :",
"annotation : AT name $$3 annotationParensOpt",
"annotationParensOpt :",
"annotationParensOpt : PARENOPEN value PARENCLOSE",
"annotationParensOpt : PARENOPEN valuePairs PARENCLOSE",
"annotationParensOpt : PARENOPEN PARENCLOSE",
"valuePairs : valuePair",
"valuePairs : valuePairs COMMA valuePair",
"valuePair : IDENTIFIER EQUALS value",
"$$4 :",
"arrayInitializer : $$4 BRACEOPEN valuesOpt BRACECLOSE",
"valuesOpt :",
"valuesOpt : values",
"values : value",
"values : values COMMA value",
"value : expression",
"value : annotation",
"value : arrayInitializer",
"expression : conditionalExpression",
"conditionalExpression : conditionalOrExpression",
"conditionalExpression : conditionalOrExpression QUERY expression COLON expression",
"conditionalOrExpression : conditionalAndExpression",
"conditionalOrExpression : conditionalOrExpression VERTLINE2 conditionalAndExpression",
"conditionalAndExpression : inclusiveOrExpression",
"conditionalAndExpression : conditionalAndExpression AMPERSAND2 inclusiveOrExpression",
"inclusiveOrExpression : exclusiveOrExpression",
"inclusiveOrExpression : inclusiveOrExpression VERTLINE exclusiveOrExpression",
"exclusiveOrExpression : andExpression",
"exclusiveOrExpression : exclusiveOrExpression CIRCUMFLEX andExpression",
"andExpression : equalityExpression",
"andExpression : andExpression AMPERSAND equalityExpression",
"equalityExpression : relationalExpression",
"equalityExpression : equalityExpression EQUALS2 relationalExpression",
"equalityExpression : equalityExpression NOTEQUALS relationalExpression",
"relationalExpression : shiftExpression",
"relationalExpression : relationalExpression LESSEQUALS shiftExpression",
"relationalExpression : relationalExpression GREATEREQUALS shiftExpression",
"relationalExpression : relationalExpression LESSTHAN shiftExpression",
"relationalExpression : relationalExpression GREATERTHAN shiftExpression",
"shiftExpression : additiveExpression",
"shiftExpression : shiftExpression LESSTHAN2 additiveExpression",
"shiftExpression : shiftExpression GREATERTHAN3 additiveExpression",
"shiftExpression : shiftExpression GREATERTHAN2 additiveExpression",
"additiveExpression : multiplicativeExpression",
"additiveExpression : additiveExpression PLUS multiplicativeExpression",
"additiveExpression : additiveExpression MINUS multiplicativeExpression",
"multiplicativeExpression : unaryExpression",
"multiplicativeExpression : multiplicativeExpression STAR unaryExpression",
"multiplicativeExpression : multiplicativeExpression SLASH unaryExpression",
"multiplicativeExpression : multiplicativeExpression PERCENT unaryExpression",
"unaryExpression : PLUS unaryExpression",
"unaryExpression : MINUS unaryExpression",
"unaryExpression : unaryExpressionNotPlusMinus",
"unaryExpressionNotPlusMinus : TILDE unaryExpression",
"unaryExpressionNotPlusMinus : EXCLAMATION unaryExpression",
"unaryExpressionNotPlusMinus : primary",
"primary : PARENOPEN primitiveType PARENCLOSE unaryExpression",
"primary : PARENOPEN primitiveType dims PARENCLOSE unaryExpression",
"primary : PARENOPEN name dims PARENCLOSE unaryExpressionNotPlusMinus",
"primary : PARENOPEN name PARENCLOSE unaryExpressionNotPlusMinus",
"primary : PARENOPEN expression PARENCLOSE",
"primary : literal",
"primary : primitiveType dims DOT CLASS",
"primary : primitiveType DOT CLASS",
"primary : name DOT CLASS",
"primary : name dims DOT CLASS",
"primary : name",
"dims : SQUAREOPEN SQUARECLOSE",
"dims : dims SQUAREOPEN SQUARECLOSE",
"name : IDENTIFIER",
"name : name DOT IDENTIFIER",
"literal : DOUBLE_LITERAL",
"literal : FLOAT_LITERAL",
"literal : LONG_LITERAL",
"literal : INTEGER_LITERAL",
"literal : BOOLEAN_LITERAL",
"literal : CHAR_LITERAL",
"literal : STRING_LITERAL",
"primitiveType : BOOLEAN",
"primitiveType : BYTE",
"primitiveType : SHORT",
"primitiveType : INT",
"primitiveType : LONG",
"primitiveType : CHAR",
"primitiveType : FLOAT",
"primitiveType : DOUBLE",
"type : classtype dimensions",
"$$5 :",
"$$6 :",
"classtype : typedeclspecifier LESSTHAN $$5 typearglist $$6 GREATERTHAN",
"classtype : typedeclspecifier",
"typedeclspecifier : typename",
"typedeclspecifier : classtype DOT IDENTIFIER",
"typename : IDENTIFIER",
"typename : typename DOT IDENTIFIER",
"typearglist : typearg",
"typearglist : typearglist COMMA typearg",
"typearg : type",
"typearg : QUERY",
"typearg : QUERY EXTENDS type",
"typearg : QUERY SUPER type",
"opt_typeparams :",
"opt_typeparams : typeparams",
"typeparams : LESSTHAN typeparamlist GREATERTHAN",
"typeparamlist : typeparam",
"typeparamlist : typeparamlist COMMA typeparam",
"typeparam : IDENTIFIER",
"typeparam : IDENTIFIER EXTENDS typeboundlist",
"typeboundlist : type",
"typeboundlist : typeboundlist AMPERSAND type",
"enum : enum_definition BRACEOPEN enum_body BRACECLOSE",
"enum_definition : modifiers ENUM IDENTIFIER opt_implements",
"enum_body : enum_values",
"enum_body : enum_values SEMI members",
"enum_values :",
"enum_values : enum_value",
"enum_values : enum_value COMMA enum_values",
"enum_value : javadoc enum_constructor",
"enum_value : opt_annotations enum_constructor",
"enum_constructor : IDENTIFIER",
"enum_constructor : IDENTIFIER CODEBLOCK",
"enum_constructor : IDENTIFIER PARENBLOCK",
"enum_constructor : IDENTIFIER PARENBLOCK CODEBLOCK",
"class : classdefinition BRACEOPEN members BRACECLOSE",
"classdefinition : modifiers classorinterface IDENTIFIER opt_typeparams opt_extends opt_implements",
"classorinterface : CLASS",
"classorinterface : INTERFACE",
"classorinterface : ANNOINTERFACE",
"opt_extends :",
"opt_extends : EXTENDS extendslist",
"extendslist : classtype",
"extendslist : extendslist COMMA classtype",
"opt_implements :",
"opt_implements : IMPLEMENTS implementslist",
"implementslist : classtype",
"implementslist : implementslist COMMA classtype",
"members :",
"$$7 :",
"members : members $$7 member",
"member : javadoc",
"member : fields",
"member : method",
"member : constructor",
"member : static_block",
"member : class",
"member : enum",
"member : SEMI",
"memberend : SEMI",
"memberend : CODEBLOCK",
"static_block : modifiers CODEBLOCK",
"$$8 :",
"fields : modifiers type arrayidentifier $$8 extrafields memberend",
"extrafields :",
"$$9 :",
"extrafields : extrafields COMMA $$9 arrayidentifier",
"method : modifiers typeparams type IDENTIFIER methoddef dimensions opt_exceptions memberend",
"method : modifiers type IDENTIFIER methoddef dimensions opt_exceptions memberend",
"constructor : modifiers IDENTIFIER methoddef opt_exceptions memberend",
"methoddef : PARENOPEN opt_params PARENCLOSE",
"opt_exceptions :",
"opt_exceptions : THROWS exceptionlist",
"exceptionlist : fullidentifier",
"exceptionlist : exceptionlist COMMA fullidentifier",
"opt_params :",
"opt_params : paramlist",
"paramlist : param",
"paramlist : paramlist COMMA param",
"param : opt_annotations opt_parammodifiers type varargs arrayidentifier",
"varargs :",
"varargs : DOTDOTDOT",
"opt_annotations :",
"opt_annotations : opt_annotations annotation",
"opt_parammodifiers :",
"opt_parammodifiers : opt_parammodifiers modifier",
};

//#line 527 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"

private Lexer lexer;
private Builder builder;
private StringBuffer textBuffer = new StringBuffer();
private ClassDef cls = new ClassDef();
private MethodDef mth = new MethodDef();
private List annotationStack = new ArrayList(); // Use ArrayList intead of Stack because it is unsynchronized 
private Annotation annotation = null;
private List annoValueListStack = new ArrayList(); // Use ArrayList intead of Stack because it is unsynchronized
private List annoValueList = null;
private FieldDef param = new FieldDef();
private java.util.Set modifiers = new java.util.HashSet();
private TypeDef fieldType;
private Stack typeStack = new Stack();
private int line;
private int column;
private boolean debugLexer;

private void appendToBuffer(String word) {
    if (textBuffer.length() > 0) {
        char lastChar = textBuffer.charAt(textBuffer.length() - 1);
        if (!Character.isWhitespace(lastChar)) {
            textBuffer.append(' ');
        }
    }
    textBuffer.append(word);
}

private String buffer() {
    String result = textBuffer.toString().trim();
    textBuffer.setLength(0);
    return result;
}

public Parser(Lexer lexer, Builder builder) {
    this.lexer = lexer;
    this.builder = builder;
}

public void setDebugParser(boolean debug) {
    yydebug = debug;
}

public void setDebugLexer(boolean debug) {
    debugLexer = debug;
}

/**
 * Parse file. Return true if successful.
 */
public boolean parse() {
    return yyparse() == 0;
}

private int yylex() {
    try {
        final int result = lexer.lex();
        yylval = new Value();
        yylval.sval = lexer.text();
        if (debugLexer) {
            System.err.println("Token: " + yyname[result] + " \"" + yylval.sval + "\"");
        }
        return result;
    }
    catch(IOException e) {
        return 0;
    }
}

private void yyerror(String msg) {
    throw new ParseException(msg, lexer.getLine(), lexer.getColumn());
}

private class Value {
	Object oval;
    String sval;
    int ival;
	boolean bval;
    TypeDef type;
    AnnotationValue annoval;
}


private void makeField(TypeDef field, String body) {
    FieldDef fd = new FieldDef();
    fd.lineNumber = line;
    fd.modifiers.addAll(modifiers); 
    fd.name = field.name;
    fd.type = fieldType;
    fd.dimensions = field.dimensions;
    fd.body = body;
    builder.addField(fd);
}

private String convertString(String str) {
	StringBuffer buf = new StringBuffer();
	boolean escaped = false;
	int unicode = 0;
	int value = 0;
	int octal = 0;
	boolean consumed = false;
	
	for(int i = 0; i < str.length(); ++ i) {
		char ch = str.charAt( i );
		
		if(octal > 0) {
			if( value >= '0' && value <= '7' ) {
				value = ( value << 3 ) | Character.digit( ch, 8 );
				-- octal;
				consumed = true;
			}
			else {
				octal = 0;
			}
			
			if( octal == 0 ) {
				buf.append( (char) value );		
				value = 0;
			}
		}
		
		if(!consumed) {
			if(unicode > 0) {
				value = ( value << 4 ) | Character.digit( ch, 16 );
				
				-- unicode;
		
				if(unicode == 0) {
					buf.append( (char)value );
					value = 0;
				}
			}
			else if(ch == '\\') {
				escaped = true;
			}
			else if(escaped) {
				if(ch == 'u' || ch == 'U') {
					unicode = 4;
				}
				else if(ch >= '0' && ch <= '7') {
					octal = (ch > '3') ? 1 : 2;
					value = Character.digit( ch, 8 );
				}
				else {
					switch( ch ) {
						case 'b':
							buf.append('\b');
							break;
							
						case 'f':
							buf.append('\f');
							break;
							
						case 'n':
							buf.append('\n');
							break;
							
						case 'r':
							buf.append('\r');
							break;
							
						case 't':
							buf.append('\t');
							break;
							
						case '\'':
							buf.append('\'');
							break;
	
						case '\"':
							buf.append('\"');
							break;
	
						case '\\':
							buf.append('\\');
							break;
							
						default:
							yyerror( "Illegal escape character '" + ch + "'" );
					}
				}
				
				escaped = false;
			}
			else {
				buf.append( ch );
			}
		}
	}

	return buf.toString();
}

private Boolean toBoolean(String str) {
	str = str.trim();

	return new Boolean( str );
}

private Integer toInteger(String str) {
	str = str.trim();
	
	Integer result;
	
	if(str.startsWith("0x") || str.startsWith( "0X" ) ) {
		result = new Integer( Integer.parseInt( str.substring( 2 ), 16 ) );
	}
	else if(str.length() > 1 && str.startsWith("0") ) {
		result = new Integer( Integer.parseInt( str.substring( 1 ), 8 ) );
	}
	else {
		result = new Integer( str );
	}
	
	return result;
}

private Long toLong(String str) {
	str = str.trim();

	Long result;
	
	if( !str.endsWith("l") && !str.endsWith("L") ) {
		yyerror( "Long literal must end with 'l' or 'L'." );
	}
	
	int len = str.length() - 1;
	
	if(str.startsWith("0x") || str.startsWith( "0X" ) ) {
		result = new Long( Long.parseLong( str.substring( 2, len ), 16 ) );
	}
	else if(str.startsWith("0") ) {
		result = new Long( Long.parseLong( str.substring( 1, len ), 8 ) );
	}
	else {
		result = new Long( str.substring( 0, len ) );
	}

	return result;
}

private Float toFloat(String str) {
	str = str.trim();
	return new Float( str );
}

private Double toDouble(String str) {
	str = str.trim();

	if( !str.endsWith("d") && !str.endsWith("D") ) {
		yyerror( "Double literal must end with 'd' or 'D'." );
	}
	
	return new Double( str.substring( 0, str.length() - 1 ) );
}

/**
 * Convert a character literal into a character.
 */
private Character toChar(String str) {
	str = str.trim();

	if( !str.startsWith("'") && !str.endsWith("'") ) {
		yyerror("Character must be single quoted.");
	}

	String str2 = convertString( str.substring( 1, str.length() - 1 ) );
	
	if( str2.length() != 1) {
		yyerror("Only one character allowed in character constants.");
	}
	
	return new Character( str2.charAt( 0 ) );
}

/**
 * Convert a string literal into a string.
 */
private String toString(String str) {
	str = str.trim();

	if( str.length() < 2 && !str.startsWith("\"") && !str.endsWith("\"") ) {
		yyerror("String must be double quoted.");
	}

	String str2 = convertString( str.substring( 1, str.length() - 1 ) );
	return str2;
}
//#line 1146 "Parser.java"
//###############################################################
// method: yylexdebug : check lexer state
//###############################################################
void yylexdebug(int state,int ch)
{
String s=null;
  if (ch < 0) ch=0;
  if (ch <= YYMAXTOKEN) //check index bounds
     s = yyname[ch];    //now get it
  if (s==null)
    s = "illegal-symbol";
  debug("state "+state+", reading "+ch+" ("+s+")");
}





//The following are now global, to aid in error reporting
int yyn;       //next next thing to do
int yym;       //
int yystate;   //current parsing state from state table
String yys;    //current token string


//###############################################################
// method: yyparse : parse input and execute indicated items
//###############################################################
int yyparse()
{
boolean doaction;
  init_stacks();
  yynerrs = 0;
  yyerrflag = 0;
  yychar = -1;          //impossible char forces a read
  yystate=0;            //initial state
  state_push(yystate);  //save it
  while (true) //until parsing is done, either correctly, or w/error
    {
    doaction=true;
    if (yydebug) debug("loop"); 
    //#### NEXT ACTION (from reduction table)
    for (yyn=yydefred[yystate];yyn==0;yyn=yydefred[yystate])
      {
      if (yydebug) debug("yyn:"+yyn+"  state:"+yystate+"  yychar:"+yychar);
      if (yychar < 0)      //we want a char?
        {
        yychar = yylex();  //get next token
        if (yydebug) debug(" next yychar:"+yychar);
        //#### ERROR CHECK ####
        if (yychar < 0)    //it it didn't work/error
          {
          yychar = 0;      //change it to default string (no -1!)
          if (yydebug)
            yylexdebug(yystate,yychar);
          }
        }//yychar<0
      yyn = yysindex[yystate];  //get amount to shift by (shift index)
      if ((yyn != 0) && (yyn += yychar) >= 0 &&
          yyn <= YYTABLESIZE && yycheck[yyn] == yychar)
        {
        if (yydebug)
          debug("state "+yystate+", shifting to state "+yytable[yyn]);
        //#### NEXT STATE ####
        yystate = yytable[yyn];//we are in a new state
        state_push(yystate);   //save it
        val_push(yylval);      //push our lval as the input for next rule
        yychar = -1;           //since we have 'eaten' a token, say we need another
        if (yyerrflag > 0)     //have we recovered an error?
           --yyerrflag;        //give ourselves credit
        doaction=false;        //but don't process yet
        break;   //quit the yyn=0 loop
        }

    yyn = yyrindex[yystate];  //reduce
    if ((yyn !=0 ) && (yyn += yychar) >= 0 &&
            yyn <= YYTABLESIZE && yycheck[yyn] == yychar)
      {   //we reduced!
      if (yydebug) debug("reduce");
      yyn = yytable[yyn];
      doaction=true; //get ready to execute
      break;         //drop down to actions
      }
    else //ERROR RECOVERY
      {
      if (yyerrflag==0)
        {
        yyerror("syntax error");
        yynerrs++;
        }
      if (yyerrflag < 3) //low error count?
        {
        yyerrflag = 3;
        while (true)   //do until break
          {
          if (stateptr<0)   //check for under & overflow here
            {
            yyerror("stack underflow. aborting...");  //note lower case 's'
            return 1;
            }
          yyn = yysindex[state_peek(0)];
          if ((yyn != 0) && (yyn += YYERRCODE) >= 0 &&
                    yyn <= YYTABLESIZE && yycheck[yyn] == YYERRCODE)
            {
            if (yydebug)
              debug("state "+state_peek(0)+", error recovery shifting to state "+yytable[yyn]+" ");
            yystate = yytable[yyn];
            state_push(yystate);
            val_push(yylval);
            doaction=false;
            break;
            }
          else
            {
            if (yydebug)
              debug("error recovery discarding state "+state_peek(0)+" ");
            if (stateptr<0)   //check for under & overflow here
              {
              yyerror("Stack underflow. aborting...");  //capital 'S'
              return 1;
              }
            state_pop();
            val_pop();
            }
          }
        }
      else            //discard this token
        {
        if (yychar == 0)
          return 1; //yyabort
        if (yydebug)
          {
          yys = null;
          if (yychar <= YYMAXTOKEN) yys = yyname[yychar];
          if (yys == null) yys = "illegal-symbol";
          debug("state "+yystate+", error recovery discards token "+yychar+" ("+yys+")");
          }
        yychar = -1;  //read another
        }
      }//end error recovery
    }//yyn=0 loop
    if (!doaction)   //any reason not to proceed?
      continue;      //skip action
    yym = yylen[yyn];          //get count of terminals on rhs
    if (yydebug)
      debug("state "+yystate+", reducing "+yym+" by rule "+yyn+" ("+yyrule[yyn]+")");
    if (yym>0)                 //if count of rhs not 'nil'
      yyval = val_peek(yym-1); //get current semantic value
    switch(yyn)
      {
//########## USER-SUPPLIED ACTIONS ##########
case 2:
//#line 56 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
{ line = lexer.getLine(); }
break;
case 4:
//#line 59 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
{ builder.addAnnotation((Annotation) val_peek(0).annoval); }
break;
case 11:
//#line 62 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
{ builder.addPackage(new PackageDef(val_peek(1).sval, line)); }
break;
case 12:
//#line 65 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
{ builder.addImport(val_peek(1).sval); }
break;
case 13:
//#line 66 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
{ builder.addImport(val_peek(1).sval); }
break;
case 15:
//#line 74 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
{ 
        builder.addJavaDoc(buffer()); 
    }
break;
case 18:
//#line 81 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
{
        appendToBuffer(val_peek(0).sval);
    }
break;
case 19:
//#line 84 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
{
        textBuffer.append('\n');
    }
break;
case 22:
//#line 91 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
{ line = lexer.getLine(); }
break;
case 23:
//#line 92 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
{
        builder.addJavaDocTag(new TagDef(val_peek(2).sval.substring(1), buffer(), line)); 
    }
break;
case 24:
//#line 101 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
{ yyval.sval = val_peek(0).sval; }
break;
case 25:
//#line 102 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
{ yyval.sval = val_peek(2).sval + '.' + val_peek(0).sval; }
break;
case 26:
//#line 103 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
{ yyval.sval = val_peek(2).sval + ".*"; }
break;
case 27:
//#line 106 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
{
        yyval.type = new TypeDef(val_peek(1).sval,val_peek(0).ival);
    }
break;
case 28:
//#line 111 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
{ yyval.ival = 0; }
break;
case 29:
//#line 112 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
{
        yyval.ival = val_peek(2).ival + 1; 
    }
break;
case 30:
//#line 118 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
{ yyval.sval = "public"; }
break;
case 31:
//#line 119 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
{ yyval.sval = "protected"; }
break;
case 32:
//#line 120 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
{ yyval.sval = "private"; }
break;
case 33:
//#line 121 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
{ yyval.sval = "static"; }
break;
case 34:
//#line 122 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
{ yyval.sval = "final"; }
break;
case 35:
//#line 123 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
{ yyval.sval = "abstract"; }
break;
case 36:
//#line 124 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
{ yyval.sval = "native"; }
break;
case 37:
//#line 125 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
{ yyval.sval = "synchronized"; }
break;
case 38:
//#line 126 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
{ yyval.sval = "volatile"; }
break;
case 39:
//#line 127 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
{ yyval.sval = "transient"; }
break;
case 40:
//#line 128 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
{ yyval.sval = "strictfp"; }
break;
case 41:
//#line 131 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
{ modifiers.add(val_peek(0).sval); }
break;
case 42:
//#line 132 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
{ builder.addAnnotation((Annotation) val_peek(0).annoval); }
break;
case 44:
//#line 142 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
{ 
    	annotationStack.add(annotation);
    	annotation = new Annotation(builder.createType(val_peek(0).sval, 0), lexer.getLine()); 
    }
break;
case 45:
//#line 147 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
{
    	yyval.annoval = annotation;
    	annotation = (Annotation)annotationStack.remove(annotationStack.size() - 1);
    }
break;
case 47:
//#line 154 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
{ annotation.setProperty("value", val_peek(1).annoval); }
break;
case 52:
//#line 163 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
{ annotation.setProperty(val_peek(2).sval, val_peek(0).annoval); }
break;
case 53:
//#line 166 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
{
    	annoValueListStack.add(annoValueList);
    	annoValueList = new ArrayList(); 
    }
break;
case 54:
//#line 171 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
{
    	yyval.annoval = new AnnotationValueList(annoValueList);
    	annoValueList = (List)annoValueListStack.remove(annoValueListStack.size() - 1);
    }
break;
case 57:
//#line 181 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
{ annoValueList.add(val_peek(0).annoval); }
break;
case 58:
//#line 182 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
{ annoValueList.add(val_peek(0).annoval); }
break;
case 59:
//#line 185 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
{ yyval.annoval = val_peek(0).annoval; }
break;
case 60:
//#line 186 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
{ yyval.annoval = val_peek(0).annoval; }
break;
case 61:
//#line 187 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
{ yyval.annoval = val_peek(0).annoval; }
break;
case 62:
//#line 190 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
{ yyval.annoval = val_peek(0).annoval; }
break;
case 63:
//#line 193 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
{ yyval.annoval = val_peek(0).annoval; }
break;
case 64:
//#line 194 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
{ yyval.annoval = new AnnotationQuery(val_peek(4).annoval, val_peek(2).annoval, val_peek(0).annoval); }
break;
case 65:
//#line 197 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
{ yyval.annoval = val_peek(0).annoval; }
break;
case 66:
//#line 198 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
{ yyval.annoval = new AnnotationLogicalOr(val_peek(2).annoval, val_peek(0).annoval); }
break;
case 67:
//#line 201 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
{ yyval.annoval = val_peek(0).annoval; }
break;
case 68:
//#line 202 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
{ yyval.annoval = new AnnotationLogicalAnd(val_peek(2).annoval, val_peek(0).annoval); }
break;
case 69:
//#line 205 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
{ yyval.annoval = val_peek(0).annoval; }
break;
case 70:
//#line 206 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
{ yyval.annoval = new AnnotationOr(val_peek(2).annoval, val_peek(0).annoval); }
break;
case 71:
//#line 209 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
{ yyval.annoval = val_peek(0).annoval; }
break;
case 72:
//#line 210 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
{ yyval.annoval = new AnnotationExclusiveOr(val_peek(2).annoval, val_peek(0).annoval); }
break;
case 73:
//#line 213 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
{ yyval.annoval = val_peek(0).annoval; }
break;
case 74:
//#line 214 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
{ yyval.annoval = new AnnotationAnd(val_peek(2).annoval, val_peek(0).annoval); }
break;
case 75:
//#line 217 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
{ yyval.annoval = val_peek(0).annoval; }
break;
case 76:
//#line 218 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
{ yyval.annoval = new AnnotationEquals(val_peek(2).annoval, val_peek(0).annoval); }
break;
case 77:
//#line 219 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
{ yyval.annoval = new AnnotationNotEquals(val_peek(2).annoval, val_peek(0).annoval); }
break;
case 78:
//#line 222 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
{ yyval.annoval = val_peek(0).annoval; }
break;
case 79:
//#line 223 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
{ yyval.annoval = new AnnotationLessEquals(val_peek(2).annoval, val_peek(0).annoval); }
break;
case 80:
//#line 224 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
{ yyval.annoval = new AnnotationGreaterEquals(val_peek(2).annoval, val_peek(0).annoval); }
break;
case 81:
//#line 225 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
{ yyval.annoval = new AnnotationLessThan(val_peek(2).annoval, val_peek(0).annoval); }
break;
case 82:
//#line 226 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
{ yyval.annoval = new AnnotationGreaterThan(val_peek(2).annoval, val_peek(0).annoval); }
break;
case 83:
//#line 229 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
{ yyval.annoval = val_peek(0).annoval; }
break;
case 84:
//#line 230 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
{ yyval.annoval = new AnnotationShiftLeft(val_peek(2).annoval, val_peek(0).annoval); }
break;
case 85:
//#line 231 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
{ yyval.annoval = new AnnotationUnsignedShiftRight(val_peek(2).annoval, val_peek(0).annoval); }
break;
case 86:
//#line 232 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
{ yyval.annoval = new AnnotationShiftRight(val_peek(2).annoval, val_peek(0).annoval); }
break;
case 87:
//#line 235 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
{ yyval.annoval = val_peek(0).annoval; }
break;
case 88:
//#line 236 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
{ yyval.annoval = new AnnotationAdd(val_peek(2).annoval, val_peek(0).annoval); }
break;
case 89:
//#line 237 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
{ yyval.annoval = new AnnotationSubtract(val_peek(2).annoval, val_peek(0).annoval); }
break;
case 90:
//#line 240 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
{ yyval.annoval = val_peek(0).annoval; }
break;
case 91:
//#line 241 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
{ yyval.annoval = new AnnotationMultiply(val_peek(2).annoval, val_peek(0).annoval); }
break;
case 92:
//#line 242 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
{ yyval.annoval = new AnnotationDivide(val_peek(2).annoval, val_peek(0).annoval); }
break;
case 93:
//#line 243 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
{ yyval.annoval = new AnnotationRemainder(val_peek(2).annoval, val_peek(0).annoval); }
break;
case 94:
//#line 246 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
{ yyval.annoval = new AnnotationPlusSign(val_peek(0).annoval); }
break;
case 95:
//#line 247 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
{ yyval.annoval = new AnnotationMinusSign(val_peek(0).annoval); }
break;
case 96:
//#line 248 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
{ yyval.annoval = val_peek(0).annoval; }
break;
case 97:
//#line 251 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
{ yyval.annoval = new AnnotationNot(val_peek(0).annoval); }
break;
case 98:
//#line 252 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
{ yyval.annoval = new AnnotationLogicalNot(val_peek(0).annoval); }
break;
case 100:
//#line 256 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
{ yyval.annoval = new AnnotationCast(builder.createType(val_peek(2).sval, 0), val_peek(0).annoval); }
break;
case 101:
//#line 257 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
{ yyval.annoval = new AnnotationCast(builder.createType(val_peek(3).sval, val_peek(2).ival), val_peek(0).annoval); }
break;
case 102:
//#line 258 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
{ yyval.annoval = new AnnotationCast(builder.createType(val_peek(3).sval, val_peek(2).ival), val_peek(0).annoval); }
break;
case 103:
//#line 259 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
{ yyval.annoval = new AnnotationCast(builder.createType(val_peek(2).sval, 0), val_peek(0).annoval); }
break;
case 104:
//#line 260 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
{ yyval.annoval = new AnnotationParenExpression(val_peek(1).annoval); }
break;
case 105:
//#line 261 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
{ yyval.annoval = val_peek(0).annoval; }
break;
case 106:
//#line 262 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
{ yyval.annoval = new AnnotationTypeRef(builder.createType(val_peek(3).sval, 0)); }
break;
case 107:
//#line 263 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
{ yyval.annoval = new AnnotationTypeRef(builder.createType(val_peek(2).sval, 0)); }
break;
case 108:
//#line 264 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
{ yyval.annoval = new AnnotationTypeRef(builder.createType(val_peek(2).sval, 0)); }
break;
case 109:
//#line 265 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
{ yyval.annoval = new AnnotationTypeRef(builder.createType(val_peek(3).sval, 0)); }
break;
case 110:
//#line 266 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
{ yyval.annoval = new AnnotationFieldRef(val_peek(0).sval); }
break;
case 111:
//#line 269 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
{ yyval.ival = 1; }
break;
case 112:
//#line 270 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
{ yyval.ival = val_peek(2).ival + 1; }
break;
case 113:
//#line 273 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
{ yyval.sval = val_peek(0).sval; }
break;
case 114:
//#line 274 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
{ yyval.sval = val_peek(2).sval + "." + val_peek(0).sval; }
break;
case 115:
//#line 277 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
{ yyval.annoval = new AnnotationConstant(toDouble(val_peek(0).sval), val_peek(0).sval); }
break;
case 116:
//#line 278 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
{ yyval.annoval = new AnnotationConstant(toFloat(val_peek(0).sval), val_peek(0).sval); }
break;
case 117:
//#line 279 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
{ yyval.annoval = new AnnotationConstant(toLong(val_peek(0).sval), val_peek(0).sval); }
break;
case 118:
//#line 280 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
{ yyval.annoval = new AnnotationConstant(toInteger(val_peek(0).sval), val_peek(0).sval); }
break;
case 119:
//#line 281 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
{ yyval.annoval = new AnnotationConstant(toBoolean(val_peek(0).sval), val_peek(0).sval); }
break;
case 120:
//#line 282 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
{ String s = lexer.getCodeBody(); yyval.annoval = new AnnotationConstant(toChar(s), s); }
break;
case 121:
//#line 283 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
{ String s = lexer.getCodeBody(); yyval.annoval = new AnnotationConstant(toString(s), s); }
break;
case 122:
//#line 286 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
{ yyval.sval = "boolean"; }
break;
case 123:
//#line 287 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
{ yyval.sval = "byte"; }
break;
case 124:
//#line 288 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
{ yyval.sval = "short"; }
break;
case 125:
//#line 289 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
{ yyval.sval = "int"; }
break;
case 126:
//#line 290 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
{ yyval.sval = "long"; }
break;
case 127:
//#line 291 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
{ yyval.sval = "char"; }
break;
case 128:
//#line 292 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
{ yyval.sval = "float"; }
break;
case 129:
//#line 293 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
{ yyval.sval = "double"; }
break;
case 130:
//#line 299 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
{
    	TypeDef td = val_peek(1).type;
    	td.dimensions = val_peek(0).ival;
        yyval.type = td;
    }
break;
case 131:
//#line 306 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
{
    		TypeDef td = new TypeDef(val_peek(1).sval,0);
    		td.actualArgumentTypes = new ArrayList();
    		yyval.type = (TypeDef) typeStack.push(td);
    	}
break;
case 132:
//#line 310 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
{ 
    		yyval.type = (TypeDef) typeStack.pop();
    	}
break;
case 133:
//#line 312 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
{
         yyval.type = val_peek(1).type;
    }
break;
case 134:
//#line 315 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
{
        yyval.type = new TypeDef(val_peek(0).sval,0); 
    }
break;
case 135:
//#line 320 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
{ yyval.sval = val_peek(0).sval; }
break;
case 136:
//#line 321 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
{ yyval.sval = val_peek(2).type.name + '.' + val_peek(0).sval; }
break;
case 137:
//#line 324 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
{ yyval.sval = val_peek(0).sval; }
break;
case 138:
//#line 325 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
{ yyval.sval = val_peek(2).sval + '.' + val_peek(0).sval; }
break;
case 139:
//#line 328 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
{ ((TypeDef) typeStack.peek()).actualArgumentTypes.add(val_peek(0).type);}
break;
case 140:
//#line 329 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
{ ((TypeDef) typeStack.peek()).actualArgumentTypes.add(val_peek(0).type);}
break;
case 141:
//#line 332 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
{ yyval.type = val_peek(0).type;}
break;
case 142:
//#line 333 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
{ yyval.type = new WildcardTypeDef();}
break;
case 143:
//#line 334 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
{ yyval.type = new WildcardTypeDef(val_peek(0).type, "extends");}
break;
case 144:
//#line 335 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
{ yyval.type = new WildcardTypeDef(val_peek(0).type, "super");}
break;
case 154:
//#line 355 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
{
  builder.endClass();
  fieldType = null;
  modifiers.clear();
}
break;
case 155:
//#line 361 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
{
    cls.lineNumber = line;
    cls.modifiers.addAll(modifiers);
    cls.name = val_peek(1).sval;
    cls.type = ClassDef.ENUM;
    builder.beginClass(cls);
    cls = new ClassDef();
    fieldType = new TypeDef(val_peek(1).sval, 0);
}
break;
case 163:
//#line 380 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
{ makeField(new TypeDef(val_peek(0).sval, 0), ""); }
break;
case 164:
//#line 381 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
{ makeField(new TypeDef(val_peek(1).sval, 0), ""); }
break;
case 165:
//#line 382 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
{ makeField(new TypeDef(val_peek(1).sval, 0), ""); }
break;
case 166:
//#line 383 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
{ makeField(new TypeDef(val_peek(2).sval, 0), ""); }
break;
case 167:
//#line 389 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
{
        builder.endClass(); 
    }
break;
case 168:
//#line 394 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
{
        cls.lineNumber = line;
        cls.modifiers.addAll(modifiers); modifiers.clear(); 
        cls.name = val_peek(3).sval;
        builder.beginClass(cls); 
        cls = new ClassDef(); 
    }
break;
case 169:
//#line 403 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
{ cls.type = ClassDef.CLASS; }
break;
case 170:
//#line 404 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
{ cls.type = ClassDef.INTERFACE; }
break;
case 171:
//#line 405 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
{ cls.type = ClassDef.ANNOTATION_TYPE; }
break;
case 174:
//#line 410 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
{ cls.extendz.add(val_peek(0).type); }
break;
case 175:
//#line 411 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
{ cls.extendz.add(val_peek(0).type); }
break;
case 178:
//#line 416 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
{ cls.implementz.add(val_peek(0).type); }
break;
case 179:
//#line 417 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
{ cls.implementz.add(val_peek(0).type); }
break;
case 181:
//#line 419 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
{ line = lexer.getLine(); }
break;
case 191:
//#line 432 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
{
      yyval.sval = "";
    }
break;
case 192:
//#line 435 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
{
	  yyval.sval = lexer.getCodeBody();
    }
break;
case 193:
//#line 440 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
{ lexer.getCodeBody(); modifiers.clear(); }
break;
case 194:
//#line 445 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
{
        fieldType = val_peek(1).type;
        makeField(val_peek(0).type, lexer.getCodeBody());
    }
break;
case 195:
//#line 449 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
{
        modifiers.clear();
    }
break;
case 197:
//#line 454 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
{ line = lexer.getLine(); }
break;
case 198:
//#line 454 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
{
        makeField(val_peek(0).type, lexer.getCodeBody());
    }
break;
case 199:
//#line 462 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
{
        mth.lineNumber = line;
        mth.modifiers.addAll(modifiers); modifiers.clear(); 
        mth.returnType = val_peek(5).type;
        mth.dimensions = val_peek(2).ival;
        mth.name = val_peek(4).sval;
        mth.body = val_peek(0).sval;
        builder.addMethod(mth);
        mth = new MethodDef(); 
    }
break;
case 200:
//#line 472 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
{
        mth.lineNumber = line;
        mth.modifiers.addAll(modifiers); modifiers.clear();
        mth.returnType = val_peek(5).type;
        mth.dimensions = val_peek(2).ival;
        mth.name = val_peek(4).sval;
        mth.body = val_peek(0).sval;
        builder.addMethod(mth);
        mth = new MethodDef();
    }
break;
case 201:
//#line 484 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
{
        mth.lineNumber = line;
        mth.modifiers.addAll(modifiers); modifiers.clear(); 
        mth.constructor = true; mth.name = val_peek(3).sval;
        mth.body = val_peek(0).sval;
        builder.addMethod(mth);
        mth = new MethodDef(); 
    }
break;
case 205:
//#line 498 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
{ mth.exceptions.add(val_peek(0).sval); }
break;
case 206:
//#line 499 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
{ mth.exceptions.add(val_peek(0).sval); }
break;
case 211:
//#line 508 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
{
        param.name = val_peek(0).type.name;
        param.type = val_peek(2).type;
        param.dimensions = val_peek(0).type.dimensions;
        param.isVarArgs = val_peek(1).bval;
        mth.params.add(param);
        param = new FieldDef();
    }
break;
case 212:
//#line 518 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
{ yyval.bval = false; }
break;
case 213:
//#line 519 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
{ yyval.bval = true; }
break;
case 217:
//#line 524 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
{ param.modifiers.add(val_peek(0).sval); }
break;
//#line 2010 "Parser.java"
//########## END OF USER-SUPPLIED ACTIONS ##########
    }//switch
    //#### Now let's reduce... ####
    if (yydebug) debug("reduce");
    state_drop(yym);             //we just reduced yylen states
    yystate = state_peek(0);     //get new state
    val_drop(yym);               //corresponding value drop
    yym = yylhs[yyn];            //select next TERMINAL(on lhs)
    if (yystate == 0 && yym == 0)//done? 'rest' state and at first TERMINAL
      {
      if (yydebug) debug("After reduction, shifting from state 0 to state "+YYFINAL+"");
      yystate = YYFINAL;         //explicitly say we're done
      state_push(YYFINAL);       //and save it
      val_push(yyval);           //also save the semantic value of parsing
      if (yychar < 0)            //we want another character?
        {
        yychar = yylex();        //get next character
        if (yychar<0) yychar=0;  //clean, if necessary
        if (yydebug)
          yylexdebug(yystate,yychar);
        }
      if (yychar == 0)          //Good exit (if lex returns 0 ;-)
         break;                 //quit the loop--all DONE
      }//if yystate
    else                        //else not done yet
      {                         //get next state and push, for next yydefred[]
      yyn = yygindex[yym];      //find out where to go
      if ((yyn != 0) && (yyn += yystate) >= 0 &&
            yyn <= YYTABLESIZE && yycheck[yyn] == yystate)
        yystate = yytable[yyn]; //get new state
      else
        yystate = yydgoto[yym]; //else go to new defred
      if (yydebug) debug("after reduction, shifting from state "+state_peek(0)+" to state "+yystate+"");
      state_push(yystate);     //going again, so push state & val...
      val_push(yyval);         //for next action
      }
    }//main loop
  return 0;//yyaccept!!
}
//## end of method parse() ######################################



//## run() --- for Thread #######################################
//## The -Jnorun option was used ##
//## end of method run() ########################################



//## Constructors ###############################################
//## The -Jnoconstruct option was used ##
//###############################################################



}
//################### END OF CLASS ##############################
